#ifndef _TASKSET_H
#define _TASKSET_H

/*
 * provide the proper syscall information if our libc is not yet updated.
 * It is suggested you check your kernel to make sure these are right for
 * your architecture.
 *
 * libc is now updated in CVS as of Aug 2002 and glibc 2.3 has support.
 */

// glibc 2.3.2 CVS as of 2003-05-09 breaks the affinity system calls
// so we need to always override them, here
#undef _GNU_SOURCE
//#include <features.h>
//#if ! __GNUC_PREREQ(2,3)

#include <errno.h>

extern int sched_setaffinity(pid_t, unsigned int, unsigned long *);
extern int sched_getaffinity(pid_t, unsigned int, unsigned long *);

#if defined(__i386__)
#define __NR_sched_setaffinity	241
#define __NR_sched_getaffinity	242
#endif

#if defined(__ia64__)
#define __NR_sched_setaffinity	1231
#define __NR_sched_getaffinity	1232
#endif

#if defined(__powerpc__)
#define __NR_sched_setaffinity	223
#define __NR_sched_getaffinity	224
#endif

#if defined(__s390__)
#define __NR_sched_setaffinity	239
#define __NR_sched_getaffinity	240
#endif

#if defined(__sparc__)
#define __NR_sched_setaffinity	160
#define __NR_sched_getaffinity	161
#endif

#if defined(__x86_64__)
#define __NR_sched_setaffinity	241
#define __NR_sched_getaffinity	242
#endif

#if defined(__ia64__)
inline int sched_setaffinity(pid_t pid, unsigned int len,
			     unsigned long * user_mask_ptr)
{
    return syscall(__NR_sched_setaffinity, pid, len, user_mask_ptr);
}

inline int sched_getaffinity(pid_t pid, unsigned int len,
			     unsigned long * user_mask_ptr)
{
    return syscall(__NR_sched_getaffinity, pid, len, user_mask_ptr);
}
#else
_syscall3(int, sched_setaffinity, pid_t, pid, unsigned int, len,
	  unsigned long *, user_mask_ptr)
_syscall3(int, sched_getaffinity, pid_t, pid, unsigned int, len,
	  unsigned long *, user_mask_ptr)
#endif

//#endif /* ! __GNUC_PREREQ(2,3) */

#endif /* _TASKSET_H */
